pub mod views;

use crate::views::personajes::genera_pj;
use crate::views::astronaves::genera_astronave;
use axum::{routing::get, Router};
use std::net::SocketAddr;

#[tokio::main]
async fn main() {
    // inicio do tracing
    tracing_subscriber::fmt::init();

    // routing
    let app = Router::new()
        .route("/", get(root))
        .route("/pjs", get(genera_pj))
        .route("/astronaves", get(genera_astronave));

    // executase con hyper a través de axum::Server
    let addr = SocketAddr::from((itkg_lib::env_listen_ip(), itkg_lib::env_listen_port()));
    tracing::debug!("listening on {}", addr);
    axum::Server::bind(&addr)
        .serve(app.into_make_service())
        .await
        .unwrap();
}

// vista básica para a raíz
async fn root() -> &'static str {
    "Generadores para el juego de rol Into the Kosmos."
}
